> def tableprint(data,headers)

输入参数：data,headers  
data:列表，存储表打印数据    
headers:列表，存储表打印表的表头  
返回值：无  
输出结果：打印表  
测试代码：
```python
  data = [
    ["John", 28, "Engineer"],  
    ["Emily", 25, "Designer"],  
    ["Michael", 32, "Manager"],  
]

headers = ["Name", "Age", "Occupation"]
tableprint(data,headers)
```

> def Confusion_matrix(outputs,true_label,all_labels,isshow)

输入参数：outputs,true_label,all_labels,isshow  
outputs：为模型预测结果 格式为1xN的矩阵，N为样本个数，如['cat','dog','cattle']  
true_label：为实际标签 格式为1XN的矩阵，N为样本个数，如['cat','dog','sheep']  
all_label：为所有分类标签的集合，格式为1XM，M为类别个数，如['cat','dog','sheep']  
isshow：布尔类型，表示是否把混淆矩阵展示出来，true为展示，false为不展示  
返回值：MXM的混淆矩阵  
输出结果：混淆矩阵图  
测试代码：
```python
x = [1,2,3,5,5,4,6,2,3,4]
y = [1,1,5,5,4,6,6,2,3,4]
Confusion_matrix(x,y,[1,2,3,4,5,6],isshow=True)
```

> def Confusion_matrix_onehot(outputs,true_label,isshow)

输入参数：outputs,true_label,isshow   
outputs：为模型预测结果 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
true_label：为实际标签 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
isshow：布尔类型，表示是否把混淆矩阵展示出来，true为展示，false为不展示  
返回值：MXM的混淆矩阵    
输出结果：混淆矩阵图  
测试代码：  
```python
import numpy as np
outputs = np.array([[1,0,0,0],[0,1,0,0],[0,1,0,0],[0,0,1,0],[0,1,0,0],[0,0,0,1]])
true_label = np.array([[1,0,0,0],[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,1,0],[0,0,0,1]])
Confusion_matrix_onehot(x,y,isshow=True)
```

> def Accuracy(outputs,labels,all_labels,isshow)

输入参数：outputs,labels,all_labels,isshow    
outputs：为模型预测结果 格式为1xN的矩阵，N为样本个数，如['cat','dog','cattle']  
labels：为实际标签 格式为1XN的矩阵，N为样本个数，如['cat','dog','sheep']  
all_label：为所有分类标签的集合，格式为1XM，M为类别个数，如['cat','dog','sheep']  
isshow：布尔类型，表示是否把混淆矩阵展示出来，true为展示，false为不展示  
返回值：所有类别的准确率，保留两位小数   
输出结果：isshow为true时打印混淆矩阵  
测试代码：  
```python
x = [1,2,3,5,5,4,6,2,3,4]
y = [1,1,5,5,4,6,6,2,3,4]
Accuracy(x,y,[1,2,3,4,5,6],isshow=True)
```

> def Accuracy_onehot(outputs,labels,isshow)

输入参数：outputs,labels,isshow   
outputs：为模型预测结果 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
labels：为实际标签 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
isshow：表示是否把混淆矩阵展示出来，true为展示，false为不展示   
返回值：所有类别的准确率，保留两位小数      
输出结果：isshow为true时打印混淆矩阵  
测试代码：  
```python
import numpy as np
outputs = np.array([[1,0,0,0],[0,1,0,0],[0,1,0,0],[0,0,1,0],[0,1,0,0],[0,0,0,1]])
true_label = np.array([[1,0,0,0],[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,1,0],[0,0,0,1]])
Accuracy_onehot(x,y,isshow=True)
```

> def Recall_score(outputs,labels,specific_label,all_labels,isshow)

输入参数：outputs,labels,specific_label,all_labels,isshow   
outputs:为模型预测结果 格式为1xN的矩阵，N为样本个数，如['cat','dog','cattle']    
labels:为实际标签 格式为1XN的矩阵，N为样本个数，如['cat','dog','sheep']  
specific_label:为具体的类别，表示要统计哪些类别的数据，如['cat']表示统计cat类别的数据  
all_label:为所有分类标签的集合，格式为1XM，M为类别个数，如['cat','dog','sheep']  
isshow:表示是否把混淆矩阵展示出来，true为展示，false为不展示  
返回值：result列表，存有统计类别的label和recall,如[['cat',1.0],['dog',0.5]]  
输出结果：isshow为true时打印混淆矩阵图；result的表打印  
测试代码：  
```python
x = [1,2,3,5,5,4,6,2,3,4]
y = [1,1,5,5,4,6,6,2,3,4]
Recall_score(x,y,[1,2],[1,2,3,4,5,6],isshow=True)
```

> def Recall_score_onehot(outputs,labels,specific_label,isshow)

输入参数：outputs,labels,specific_label,isshow  
outputs：为模型预测结果 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
labels：为实际标签 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
specific_label：为具体的类别，格式为1XN的矩阵，表示要统计哪些类别的数据，如[0,3]表示统计类别0和类别3的数据  
isshow：布尔类型，表示是否把混淆矩阵展示出来，true为展示，false为不展示  
返回值：result列表，存有统计类别的label和recall,如[[0,0.67],[1,0.5]]  
输出结果：isshow为true时打印混淆矩阵图；result的表打印  
测试代码：  
```python
import numpy as np
outputs = np.array([[1,0,0,0],[0,1,0,0],[0,1,0,0],[0,0,1,0],[0,1,0,0],[0,0,0,1]])
true_label = np.array([[1,0,0,0],[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,1,0],[0,0,0,1]])
Recall_score_onehot(x,y,[0,2],isshow=True)
```


> def Precision(outputs,labels,specific_label,all_labels,isshow):

输入参数：outputs,labels,specific_label,all_labels,isshow
outputs：为模型预测结果 格式为1xN的矩阵，N为样本个数，如['cat','dog','cattle']  
labels：为实际标签 格式为1XN的矩阵，N为样本个数，如['cat','dog','sheep']   
specific_label:为具体的类别，表示要统计哪些类别的数据，如['cat']表示统计cat类别的数据   
all_label：为所有分类标签的集合，格式为1XM，M为类别个数，如['cat','dog','sheep']  
isshow：布尔类型，表示是否把混淆矩阵展示出来，true为展示，false为不展示  
返回值：result列表，存有统计类别的label和precision,如[['cat',1.0],['dog',0.5]] 
输出结果：isshow为true时打印混淆矩阵图；result的表打印  
测试代码：  
```python
x = [1,2,3,5,5,4,6,2,3,4]
y = [1,1,5,5,4,6,6,2,3,4]
Precision(x,y,[0,3],[1,2,3,4,5,6],isshow=True)
```

> def Precision_onehot(outputs,labels,specific_label,isshow)

输入参数：outputs,labels,specific_label,isshow  
outputs：模型预测结果 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
labels：格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
specific_label：具体的类别，格式为1XN的矩阵，表示要统计哪些类别的数据，如[0,3]表示统计类别0和类别3的数据  
isshow：表示是否把混淆矩阵展示出来，true为展示，false为不展示   
返回值：result为一个列表，存有统计类别的label和precision,如[[0,0.67],[3,0.5]]  
输出结果：isshow为true时打印混淆矩阵图；result的表打印   
测试代码：  
```python
import numpy as np
outputs = np.array([[1,0,0,0],[0,1,0,0],[0,1,0,0],[0,0,1,0],[0,1,0,0],[0,0,0,1]])
true_label = np.array([[1,0,0,0],[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,1,0],[0,0,0,1]])
Precision_onehot(outputs,true_label,[0,2],isshow = True)
```

> def F1_score(outputs,labels,specific_label,all_labels,isshow)

输入参数：ooutputs,labels,specific_label,all_labels,isshow  
outputs：为模型预测结果 格式为1xN的矩阵，N为样本个数，如['cat','dog','cattle']  
labels：为实际标签 格式为1XN的矩阵，N为样本个数，如['cat','dog','sheep']  
specific_label：具体的类别，表示要统计哪些类别的数据，如['cat']表示统计cat类别的数据  
all_label：为所有分类标签的集合，格式为1XM，M为类别个数，如['cat','dog','sheep']   
isshow：布尔类型，表示是否把混淆矩阵展示出来，true为展示，false为不展示  
返回值：result列表，存有统计类别的label和recall,precision,f1-score，如[['cat',1.0,0.5,0.67],['dog',0.5,0.5,0.5]]  
输出结果：isshow为true时打印混淆矩阵图；result的表打印  
测试代码：  
```python
x = [1,2,3,5,5,4,6,2,3,4]
y = [1,1,5,5,4,6,6,2,3,4]
F1_score(x,y,[3,4],[1,2,3,4,5,6],isshow=True)
```

> def F1_score_onehot(outputs,labels,specific_label,isshow)

输入参数：outputs,labels,specific_label,isshow    
outputs：模型预测结果 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
labels：实际标签 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
specific_label：具体的类别，格式为1XN的矩阵，表示要统计哪些类别的数据，如[0,3]表示统计类别0和类别3的数据  
isshow：表示是否把混淆矩阵展示出来，true为展示，false为不展示  
返回值：result列表，存有统计类别的label和recall,precision,f1-score,如[[0,0.5,0.5,0.5],[3,1.0,0.5,0.67]]  
输出结果：isshow为true时打印混淆矩阵图；result的表打印  
测试代码：  
```python
import numpy as np
outputs = np.array([[1,0,0,0],[0,1,0,0],[0,1,0,0],[0,0,1,0],[0,1,0,0],[0,0,0,1]])
true_label = np.array([[1,0,0,0],[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,1,0],[0,0,0,1]])
F1_score_onehot(outputs,true_label,[0,1,2,3],isshow = True)
```


> def base_indicators(outputs,labels,all_labels,isshow)

输入参数：outputs,labels,all_labels,isshow  
outputs：为模型预测结果 格式为1xN的矩阵，N为样本个数，如['cat','dog','cattle']  
labels：为实际标签 格式为1XN的矩阵，N为样本个数，如['cat','dog','sheep']  
all_labels：为所有分类标签的集合，格式为1XM，M为类别个数，如['cat','dog','sheep']  
isshow：布尔类型，表示是否把混淆矩阵展示出来，true为展示，false为不展示  
返回值：result列表，存有统计类别的label和recall,precision,f1-score，如[['cat',1.0,0.5,0.67],['dog',0.5,0.5,0.5]]  
输出结果：isshow为true时打印混淆矩阵图；result的表打印  
测试代码：  
```python
x = [1,2,3,5,5,4,6,2,3,4]
y = [1,1,5,5,4,6,6,2,3,4]
base_indicators(x,y,[1,2,3,4,5,6],isshow=True)
```

> def base_indicators_onehot(outputs,labels,isshow)

输入参数：ooutputs,labels,isshow  
outputs：模型预测结果 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
labels：实际标签 格式为NXM的one-hot矩阵，N为样本个数，M为分类个数，如[[0,0,0,1],[1,0,0,0]] 两个样本的四分类任务  
specific_label：具体的类别，格式为1XN的矩阵，表示要统计哪些类别的数据，如[0,3]表示统计类别0和类别3的数据  
isshow：表示是否把混淆矩阵展示出来，true为展示，false为不展示  
返回值：result列表，存有统计类别的label和recall,precision,f1-score,如[[0,0.5,0.5,0.5],[3,1.0,0.5,0.67]]  
输出结果：isshow为true时打印混淆矩阵图；result的表打印  
测试代码：  
```python
import numpy as np
outputs = np.array([[1,0,0,0],[0,1,0,0],[0,1,0,0],[0,0,1,0],[0,1,0,0],[0,0,0,1]])
true_label = np.array([[1,0,0,0],[1,0,0,0],[0,1,0,0],[0,0,1,0],[0,0,1,0],[0,0,0,1]])
base_indicators_onehot(outputs,true_label,isshow = True)
```
